# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ContainerClone',
    'ContainerConsole',
    'ContainerCpu',
    'ContainerDevicePassthrough',
    'ContainerDisk',
    'ContainerFeatures',
    'ContainerInitialization',
    'ContainerInitializationDns',
    'ContainerInitializationIpConfig',
    'ContainerInitializationIpConfigIpv4',
    'ContainerInitializationIpConfigIpv6',
    'ContainerInitializationUserAccount',
    'ContainerMemory',
    'ContainerMountPoint',
    'ContainerNetworkInterface',
    'ContainerOperatingSystem',
    'ContainerStartup',
]

@pulumi.output_type
class ContainerClone(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "vmId":
            suggest = "vm_id"
        elif key == "datastoreId":
            suggest = "datastore_id"
        elif key == "nodeName":
            suggest = "node_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ContainerClone. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ContainerClone.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ContainerClone.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 vm_id: builtins.int,
                 datastore_id: Optional[builtins.str] = None,
                 node_name: Optional[builtins.str] = None):
        """
        :param builtins.int vm_id: The identifier for the source container.
        :param builtins.str datastore_id: The identifier for the target datastore.
        :param builtins.str node_name: The name of the source node (leave blank, if
               equal to the `node_name` argument).
        """
        pulumi.set(__self__, "vm_id", vm_id)
        if datastore_id is not None:
            pulumi.set(__self__, "datastore_id", datastore_id)
        if node_name is not None:
            pulumi.set(__self__, "node_name", node_name)

    @property
    @pulumi.getter(name="vmId")
    def vm_id(self) -> builtins.int:
        """
        The identifier for the source container.
        """
        return pulumi.get(self, "vm_id")

    @property
    @pulumi.getter(name="datastoreId")
    def datastore_id(self) -> Optional[builtins.str]:
        """
        The identifier for the target datastore.
        """
        return pulumi.get(self, "datastore_id")

    @property
    @pulumi.getter(name="nodeName")
    def node_name(self) -> Optional[builtins.str]:
        """
        The name of the source node (leave blank, if
        equal to the `node_name` argument).
        """
        return pulumi.get(self, "node_name")


@pulumi.output_type
class ContainerConsole(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ttyCount":
            suggest = "tty_count"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ContainerConsole. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ContainerConsole.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ContainerConsole.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 enabled: Optional[builtins.bool] = None,
                 tty_count: Optional[builtins.int] = None,
                 type: Optional[builtins.str] = None):
        """
        :param builtins.bool enabled: Whether to enable the console device (defaults
               to `true`).
        :param builtins.int tty_count: The number of available TTY (defaults to `2`).
        :param builtins.str type: The console mode (defaults to `tty`).
        """
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if tty_count is not None:
            pulumi.set(__self__, "tty_count", tty_count)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[builtins.bool]:
        """
        Whether to enable the console device (defaults
        to `true`).
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="ttyCount")
    def tty_count(self) -> Optional[builtins.int]:
        """
        The number of available TTY (defaults to `2`).
        """
        return pulumi.get(self, "tty_count")

    @property
    @pulumi.getter
    def type(self) -> Optional[builtins.str]:
        """
        The console mode (defaults to `tty`).
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class ContainerCpu(dict):
    def __init__(__self__, *,
                 architecture: Optional[builtins.str] = None,
                 cores: Optional[builtins.int] = None,
                 units: Optional[builtins.int] = None):
        """
        :param builtins.str architecture: The CPU architecture (defaults to `amd64`).
        :param builtins.int cores: The number of CPU cores (defaults to `1`).
        :param builtins.int units: The CPU units (defaults to `1024`).
        """
        if architecture is not None:
            pulumi.set(__self__, "architecture", architecture)
        if cores is not None:
            pulumi.set(__self__, "cores", cores)
        if units is not None:
            pulumi.set(__self__, "units", units)

    @property
    @pulumi.getter
    def architecture(self) -> Optional[builtins.str]:
        """
        The CPU architecture (defaults to `amd64`).
        """
        return pulumi.get(self, "architecture")

    @property
    @pulumi.getter
    def cores(self) -> Optional[builtins.int]:
        """
        The number of CPU cores (defaults to `1`).
        """
        return pulumi.get(self, "cores")

    @property
    @pulumi.getter
    def units(self) -> Optional[builtins.int]:
        """
        The CPU units (defaults to `1024`).
        """
        return pulumi.get(self, "units")


@pulumi.output_type
class ContainerDevicePassthrough(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "denyWrite":
            suggest = "deny_write"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ContainerDevicePassthrough. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ContainerDevicePassthrough.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ContainerDevicePassthrough.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 path: builtins.str,
                 deny_write: Optional[builtins.bool] = None,
                 gid: Optional[builtins.int] = None,
                 mode: Optional[builtins.str] = None,
                 uid: Optional[builtins.int] = None):
        """
        :param builtins.str path: Device to pass through to the container (e.g. `/dev/sda`).
        :param builtins.bool deny_write: Deny the container to write to the device (defaults to `false`).
        :param builtins.int gid: Group ID to be assigned to the device node.
        :param builtins.str mode: Access mode to be set on the device node. Must be a
               4-digit octal number.
        :param builtins.int uid: User ID to be assigned to the device node.
        """
        pulumi.set(__self__, "path", path)
        if deny_write is not None:
            pulumi.set(__self__, "deny_write", deny_write)
        if gid is not None:
            pulumi.set(__self__, "gid", gid)
        if mode is not None:
            pulumi.set(__self__, "mode", mode)
        if uid is not None:
            pulumi.set(__self__, "uid", uid)

    @property
    @pulumi.getter
    def path(self) -> builtins.str:
        """
        Device to pass through to the container (e.g. `/dev/sda`).
        """
        return pulumi.get(self, "path")

    @property
    @pulumi.getter(name="denyWrite")
    def deny_write(self) -> Optional[builtins.bool]:
        """
        Deny the container to write to the device (defaults to `false`).
        """
        return pulumi.get(self, "deny_write")

    @property
    @pulumi.getter
    def gid(self) -> Optional[builtins.int]:
        """
        Group ID to be assigned to the device node.
        """
        return pulumi.get(self, "gid")

    @property
    @pulumi.getter
    def mode(self) -> Optional[builtins.str]:
        """
        Access mode to be set on the device node. Must be a
        4-digit octal number.
        """
        return pulumi.get(self, "mode")

    @property
    @pulumi.getter
    def uid(self) -> Optional[builtins.int]:
        """
        User ID to be assigned to the device node.
        """
        return pulumi.get(self, "uid")


@pulumi.output_type
class ContainerDisk(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "datastoreId":
            suggest = "datastore_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ContainerDisk. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ContainerDisk.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ContainerDisk.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 datastore_id: Optional[builtins.str] = None,
                 size: Optional[builtins.int] = None):
        """
        :param builtins.str datastore_id: The identifier for the datastore to create the
               disk in (defaults to `local`).
        :param builtins.int size: The size of the root filesystem in gigabytes (defaults
               to `4`). When set to 0 a directory or zfs/btrfs subvolume will be created.
               Requires `datastore_id` to be set.
        """
        if datastore_id is not None:
            pulumi.set(__self__, "datastore_id", datastore_id)
        if size is not None:
            pulumi.set(__self__, "size", size)

    @property
    @pulumi.getter(name="datastoreId")
    def datastore_id(self) -> Optional[builtins.str]:
        """
        The identifier for the datastore to create the
        disk in (defaults to `local`).
        """
        return pulumi.get(self, "datastore_id")

    @property
    @pulumi.getter
    def size(self) -> Optional[builtins.int]:
        """
        The size of the root filesystem in gigabytes (defaults
        to `4`). When set to 0 a directory or zfs/btrfs subvolume will be created.
        Requires `datastore_id` to be set.
        """
        return pulumi.get(self, "size")


@pulumi.output_type
class ContainerFeatures(dict):
    def __init__(__self__, *,
                 fuse: Optional[builtins.bool] = None,
                 keyctl: Optional[builtins.bool] = None,
                 mounts: Optional[Sequence[builtins.str]] = None,
                 nesting: Optional[builtins.bool] = None):
        """
        :param builtins.bool fuse: Whether the container supports FUSE mounts (defaults
               to `false`)
        :param builtins.bool keyctl: Whether the container supports `keyctl()` system
               call (defaults to `false`)
        :param Sequence[builtins.str] mounts: List of allowed mount types (`cifs` or `nfs`)
        :param builtins.bool nesting: Whether the container is nested (defaults
               to `false`)
        """
        if fuse is not None:
            pulumi.set(__self__, "fuse", fuse)
        if keyctl is not None:
            pulumi.set(__self__, "keyctl", keyctl)
        if mounts is not None:
            pulumi.set(__self__, "mounts", mounts)
        if nesting is not None:
            pulumi.set(__self__, "nesting", nesting)

    @property
    @pulumi.getter
    def fuse(self) -> Optional[builtins.bool]:
        """
        Whether the container supports FUSE mounts (defaults
        to `false`)
        """
        return pulumi.get(self, "fuse")

    @property
    @pulumi.getter
    def keyctl(self) -> Optional[builtins.bool]:
        """
        Whether the container supports `keyctl()` system
        call (defaults to `false`)
        """
        return pulumi.get(self, "keyctl")

    @property
    @pulumi.getter
    def mounts(self) -> Optional[Sequence[builtins.str]]:
        """
        List of allowed mount types (`cifs` or `nfs`)
        """
        return pulumi.get(self, "mounts")

    @property
    @pulumi.getter
    def nesting(self) -> Optional[builtins.bool]:
        """
        Whether the container is nested (defaults
        to `false`)
        """
        return pulumi.get(self, "nesting")


@pulumi.output_type
class ContainerInitialization(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ipConfigs":
            suggest = "ip_configs"
        elif key == "userAccount":
            suggest = "user_account"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ContainerInitialization. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ContainerInitialization.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ContainerInitialization.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 dns: Optional['outputs.ContainerInitializationDns'] = None,
                 hostname: Optional[builtins.str] = None,
                 ip_configs: Optional[Sequence['outputs.ContainerInitializationIpConfig']] = None,
                 user_account: Optional['outputs.ContainerInitializationUserAccount'] = None):
        """
        :param 'ContainerInitializationDnsArgs' dns: The DNS configuration.
        :param builtins.str hostname: The hostname.
        :param Sequence['ContainerInitializationIpConfigArgs'] ip_configs: The IP configuration (one block per network
               device).
        :param 'ContainerInitializationUserAccountArgs' user_account: The user account configuration.
        """
        if dns is not None:
            pulumi.set(__self__, "dns", dns)
        if hostname is not None:
            pulumi.set(__self__, "hostname", hostname)
        if ip_configs is not None:
            pulumi.set(__self__, "ip_configs", ip_configs)
        if user_account is not None:
            pulumi.set(__self__, "user_account", user_account)

    @property
    @pulumi.getter
    def dns(self) -> Optional['outputs.ContainerInitializationDns']:
        """
        The DNS configuration.
        """
        return pulumi.get(self, "dns")

    @property
    @pulumi.getter
    def hostname(self) -> Optional[builtins.str]:
        """
        The hostname.
        """
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter(name="ipConfigs")
    def ip_configs(self) -> Optional[Sequence['outputs.ContainerInitializationIpConfig']]:
        """
        The IP configuration (one block per network
        device).
        """
        return pulumi.get(self, "ip_configs")

    @property
    @pulumi.getter(name="userAccount")
    def user_account(self) -> Optional['outputs.ContainerInitializationUserAccount']:
        """
        The user account configuration.
        """
        return pulumi.get(self, "user_account")


@pulumi.output_type
class ContainerInitializationDns(dict):
    def __init__(__self__, *,
                 domain: Optional[builtins.str] = None,
                 server: Optional[builtins.str] = None,
                 servers: Optional[Sequence[builtins.str]] = None):
        """
        :param builtins.str domain: The DNS search domain.
        :param builtins.str server: The DNS server. The `server` attribute is
               deprecated and will be removed in a future release. Please use
               the `servers` attribute instead.
        :param Sequence[builtins.str] servers: The list of DNS servers.
        """
        if domain is not None:
            pulumi.set(__self__, "domain", domain)
        if server is not None:
            pulumi.set(__self__, "server", server)
        if servers is not None:
            pulumi.set(__self__, "servers", servers)

    @property
    @pulumi.getter
    def domain(self) -> Optional[builtins.str]:
        """
        The DNS search domain.
        """
        return pulumi.get(self, "domain")

    @property
    @pulumi.getter
    @_utilities.deprecated("""The `server` attribute is deprecated and will be removed in a future release. Please use the `servers` attribute instead.""")
    def server(self) -> Optional[builtins.str]:
        """
        The DNS server. The `server` attribute is
        deprecated and will be removed in a future release. Please use
        the `servers` attribute instead.
        """
        return pulumi.get(self, "server")

    @property
    @pulumi.getter
    def servers(self) -> Optional[Sequence[builtins.str]]:
        """
        The list of DNS servers.
        """
        return pulumi.get(self, "servers")


@pulumi.output_type
class ContainerInitializationIpConfig(dict):
    def __init__(__self__, *,
                 ipv4: Optional['outputs.ContainerInitializationIpConfigIpv4'] = None,
                 ipv6: Optional['outputs.ContainerInitializationIpConfigIpv6'] = None):
        """
        :param 'ContainerInitializationIpConfigIpv4Args' ipv4: The IPv4 configuration.
        :param 'ContainerInitializationIpConfigIpv6Args' ipv6: The IPv4 configuration.
        """
        if ipv4 is not None:
            pulumi.set(__self__, "ipv4", ipv4)
        if ipv6 is not None:
            pulumi.set(__self__, "ipv6", ipv6)

    @property
    @pulumi.getter
    def ipv4(self) -> Optional['outputs.ContainerInitializationIpConfigIpv4']:
        """
        The IPv4 configuration.
        """
        return pulumi.get(self, "ipv4")

    @property
    @pulumi.getter
    def ipv6(self) -> Optional['outputs.ContainerInitializationIpConfigIpv6']:
        """
        The IPv4 configuration.
        """
        return pulumi.get(self, "ipv6")


@pulumi.output_type
class ContainerInitializationIpConfigIpv4(dict):
    def __init__(__self__, *,
                 address: Optional[builtins.str] = None,
                 gateway: Optional[builtins.str] = None):
        """
        :param builtins.str address: The IPv4 address (use `dhcp` for auto-discovery).
        :param builtins.str gateway: The IPv4 gateway (must be omitted
               when `dhcp` is used as the address).
        """
        if address is not None:
            pulumi.set(__self__, "address", address)
        if gateway is not None:
            pulumi.set(__self__, "gateway", gateway)

    @property
    @pulumi.getter
    def address(self) -> Optional[builtins.str]:
        """
        The IPv4 address (use `dhcp` for auto-discovery).
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter
    def gateway(self) -> Optional[builtins.str]:
        """
        The IPv4 gateway (must be omitted
        when `dhcp` is used as the address).
        """
        return pulumi.get(self, "gateway")


@pulumi.output_type
class ContainerInitializationIpConfigIpv6(dict):
    def __init__(__self__, *,
                 address: Optional[builtins.str] = None,
                 gateway: Optional[builtins.str] = None):
        """
        :param builtins.str address: The IPv6 address (use `dhcp` for auto-discovery).
        :param builtins.str gateway: The IPv6 gateway (must be omitted
               when `dhcp` is used as the address).
        """
        if address is not None:
            pulumi.set(__self__, "address", address)
        if gateway is not None:
            pulumi.set(__self__, "gateway", gateway)

    @property
    @pulumi.getter
    def address(self) -> Optional[builtins.str]:
        """
        The IPv6 address (use `dhcp` for auto-discovery).
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter
    def gateway(self) -> Optional[builtins.str]:
        """
        The IPv6 gateway (must be omitted
        when `dhcp` is used as the address).
        """
        return pulumi.get(self, "gateway")


@pulumi.output_type
class ContainerInitializationUserAccount(dict):
    def __init__(__self__, *,
                 keys: Optional[Sequence[builtins.str]] = None,
                 password: Optional[builtins.str] = None):
        """
        :param Sequence[builtins.str] keys: The SSH keys for the root account.
        :param builtins.str password: The password for the root account.
        """
        if keys is not None:
            pulumi.set(__self__, "keys", keys)
        if password is not None:
            pulumi.set(__self__, "password", password)

    @property
    @pulumi.getter
    def keys(self) -> Optional[Sequence[builtins.str]]:
        """
        The SSH keys for the root account.
        """
        return pulumi.get(self, "keys")

    @property
    @pulumi.getter
    def password(self) -> Optional[builtins.str]:
        """
        The password for the root account.
        """
        return pulumi.get(self, "password")


@pulumi.output_type
class ContainerMemory(dict):
    def __init__(__self__, *,
                 dedicated: Optional[builtins.int] = None,
                 swap: Optional[builtins.int] = None):
        """
        :param builtins.int dedicated: The dedicated memory in megabytes (defaults
               to `512`).
        :param builtins.int swap: The swap size in megabytes (defaults to `0`).
        """
        if dedicated is not None:
            pulumi.set(__self__, "dedicated", dedicated)
        if swap is not None:
            pulumi.set(__self__, "swap", swap)

    @property
    @pulumi.getter
    def dedicated(self) -> Optional[builtins.int]:
        """
        The dedicated memory in megabytes (defaults
        to `512`).
        """
        return pulumi.get(self, "dedicated")

    @property
    @pulumi.getter
    def swap(self) -> Optional[builtins.int]:
        """
        The swap size in megabytes (defaults to `0`).
        """
        return pulumi.get(self, "swap")


@pulumi.output_type
class ContainerMountPoint(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "mountOptions":
            suggest = "mount_options"
        elif key == "readOnly":
            suggest = "read_only"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ContainerMountPoint. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ContainerMountPoint.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ContainerMountPoint.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 path: builtins.str,
                 volume: builtins.str,
                 acl: Optional[builtins.bool] = None,
                 backup: Optional[builtins.bool] = None,
                 mount_options: Optional[Sequence[builtins.str]] = None,
                 quota: Optional[builtins.bool] = None,
                 read_only: Optional[builtins.bool] = None,
                 replicate: Optional[builtins.bool] = None,
                 shared: Optional[builtins.bool] = None,
                 size: Optional[builtins.str] = None):
        """
        :param builtins.str path: Path to the mount point as seen from inside the
               container.
        :param builtins.str volume: Volume, device or directory to mount into the
               container.
        :param builtins.bool acl: Explicitly enable or disable ACL support.
        :param builtins.bool backup: Whether to include the mount point in backups (only
               used for volume mount points, defaults to `false`).
        :param Sequence[builtins.str] mount_options: List of extra mount options.
        :param builtins.bool quota: Enable user quotas inside the container (not supported
               with ZFS subvolumes).
        :param builtins.bool read_only: Read-only mount point.
        :param builtins.bool replicate: Will include this volume to a storage replica job.
        :param builtins.bool shared: Mark this non-volume mount point as available on all
               nodes.
        :param builtins.str size: Volume size (only for volume mount points).
               Can be specified with a unit suffix (e.g. `10G`).
        """
        pulumi.set(__self__, "path", path)
        pulumi.set(__self__, "volume", volume)
        if acl is not None:
            pulumi.set(__self__, "acl", acl)
        if backup is not None:
            pulumi.set(__self__, "backup", backup)
        if mount_options is not None:
            pulumi.set(__self__, "mount_options", mount_options)
        if quota is not None:
            pulumi.set(__self__, "quota", quota)
        if read_only is not None:
            pulumi.set(__self__, "read_only", read_only)
        if replicate is not None:
            pulumi.set(__self__, "replicate", replicate)
        if shared is not None:
            pulumi.set(__self__, "shared", shared)
        if size is not None:
            pulumi.set(__self__, "size", size)

    @property
    @pulumi.getter
    def path(self) -> builtins.str:
        """
        Path to the mount point as seen from inside the
        container.
        """
        return pulumi.get(self, "path")

    @property
    @pulumi.getter
    def volume(self) -> builtins.str:
        """
        Volume, device or directory to mount into the
        container.
        """
        return pulumi.get(self, "volume")

    @property
    @pulumi.getter
    def acl(self) -> Optional[builtins.bool]:
        """
        Explicitly enable or disable ACL support.
        """
        return pulumi.get(self, "acl")

    @property
    @pulumi.getter
    def backup(self) -> Optional[builtins.bool]:
        """
        Whether to include the mount point in backups (only
        used for volume mount points, defaults to `false`).
        """
        return pulumi.get(self, "backup")

    @property
    @pulumi.getter(name="mountOptions")
    def mount_options(self) -> Optional[Sequence[builtins.str]]:
        """
        List of extra mount options.
        """
        return pulumi.get(self, "mount_options")

    @property
    @pulumi.getter
    def quota(self) -> Optional[builtins.bool]:
        """
        Enable user quotas inside the container (not supported
        with ZFS subvolumes).
        """
        return pulumi.get(self, "quota")

    @property
    @pulumi.getter(name="readOnly")
    def read_only(self) -> Optional[builtins.bool]:
        """
        Read-only mount point.
        """
        return pulumi.get(self, "read_only")

    @property
    @pulumi.getter
    def replicate(self) -> Optional[builtins.bool]:
        """
        Will include this volume to a storage replica job.
        """
        return pulumi.get(self, "replicate")

    @property
    @pulumi.getter
    def shared(self) -> Optional[builtins.bool]:
        """
        Mark this non-volume mount point as available on all
        nodes.
        """
        return pulumi.get(self, "shared")

    @property
    @pulumi.getter
    def size(self) -> Optional[builtins.str]:
        """
        Volume size (only for volume mount points).
        Can be specified with a unit suffix (e.g. `10G`).
        """
        return pulumi.get(self, "size")


@pulumi.output_type
class ContainerNetworkInterface(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "macAddress":
            suggest = "mac_address"
        elif key == "rateLimit":
            suggest = "rate_limit"
        elif key == "vlanId":
            suggest = "vlan_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ContainerNetworkInterface. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ContainerNetworkInterface.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ContainerNetworkInterface.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: builtins.str,
                 bridge: Optional[builtins.str] = None,
                 enabled: Optional[builtins.bool] = None,
                 firewall: Optional[builtins.bool] = None,
                 mac_address: Optional[builtins.str] = None,
                 mtu: Optional[builtins.int] = None,
                 rate_limit: Optional[builtins.float] = None,
                 vlan_id: Optional[builtins.int] = None):
        """
        :param builtins.str name: The network interface name.
        :param builtins.str bridge: The name of the network bridge (defaults
               to `vmbr0`).
        :param builtins.bool enabled: Whether to enable the network device (defaults
               to `true`).
        :param builtins.bool firewall: Whether this interface's firewall rules should be
               used (defaults to `false`).
        :param builtins.str mac_address: The MAC address.
        :param builtins.int mtu: Maximum transfer unit of the interface. Cannot be
               larger than the bridge's MTU.
        :param builtins.float rate_limit: The rate limit in megabytes per second.
        :param builtins.int vlan_id: The VLAN identifier.
        """
        pulumi.set(__self__, "name", name)
        if bridge is not None:
            pulumi.set(__self__, "bridge", bridge)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if firewall is not None:
            pulumi.set(__self__, "firewall", firewall)
        if mac_address is not None:
            pulumi.set(__self__, "mac_address", mac_address)
        if mtu is not None:
            pulumi.set(__self__, "mtu", mtu)
        if rate_limit is not None:
            pulumi.set(__self__, "rate_limit", rate_limit)
        if vlan_id is not None:
            pulumi.set(__self__, "vlan_id", vlan_id)

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The network interface name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def bridge(self) -> Optional[builtins.str]:
        """
        The name of the network bridge (defaults
        to `vmbr0`).
        """
        return pulumi.get(self, "bridge")

    @property
    @pulumi.getter
    def enabled(self) -> Optional[builtins.bool]:
        """
        Whether to enable the network device (defaults
        to `true`).
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def firewall(self) -> Optional[builtins.bool]:
        """
        Whether this interface's firewall rules should be
        used (defaults to `false`).
        """
        return pulumi.get(self, "firewall")

    @property
    @pulumi.getter(name="macAddress")
    def mac_address(self) -> Optional[builtins.str]:
        """
        The MAC address.
        """
        return pulumi.get(self, "mac_address")

    @property
    @pulumi.getter
    def mtu(self) -> Optional[builtins.int]:
        """
        Maximum transfer unit of the interface. Cannot be
        larger than the bridge's MTU.
        """
        return pulumi.get(self, "mtu")

    @property
    @pulumi.getter(name="rateLimit")
    def rate_limit(self) -> Optional[builtins.float]:
        """
        The rate limit in megabytes per second.
        """
        return pulumi.get(self, "rate_limit")

    @property
    @pulumi.getter(name="vlanId")
    def vlan_id(self) -> Optional[builtins.int]:
        """
        The VLAN identifier.
        """
        return pulumi.get(self, "vlan_id")


@pulumi.output_type
class ContainerOperatingSystem(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "templateFileId":
            suggest = "template_file_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ContainerOperatingSystem. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ContainerOperatingSystem.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ContainerOperatingSystem.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 template_file_id: builtins.str,
                 type: Optional[builtins.str] = None):
        """
        :param builtins.str template_file_id: The identifier for an OS template file.
               The ID format is `<datastore_id>:<content_type>/<file_name>`, for example `local:iso/jammy-server-cloudimg-amd64.tar.gz`.
               Can be also taken from `Download.File` resource, or from the output of `pvesm list <storage>`.
        :param builtins.str type: The type (defaults to `unmanaged`).
        """
        pulumi.set(__self__, "template_file_id", template_file_id)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="templateFileId")
    def template_file_id(self) -> builtins.str:
        """
        The identifier for an OS template file.
        The ID format is `<datastore_id>:<content_type>/<file_name>`, for example `local:iso/jammy-server-cloudimg-amd64.tar.gz`.
        Can be also taken from `Download.File` resource, or from the output of `pvesm list <storage>`.
        """
        return pulumi.get(self, "template_file_id")

    @property
    @pulumi.getter
    def type(self) -> Optional[builtins.str]:
        """
        The type (defaults to `unmanaged`).
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class ContainerStartup(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "downDelay":
            suggest = "down_delay"
        elif key == "upDelay":
            suggest = "up_delay"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ContainerStartup. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ContainerStartup.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ContainerStartup.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 down_delay: Optional[builtins.int] = None,
                 order: Optional[builtins.int] = None,
                 up_delay: Optional[builtins.int] = None):
        """
        :param builtins.int down_delay: A non-negative number defining the delay in
               seconds before the next container is shut down.
        :param builtins.int order: A non-negative number defining the general startup
               order.
        :param builtins.int up_delay: A non-negative number defining the delay in
               seconds before the next container is started.
        """
        if down_delay is not None:
            pulumi.set(__self__, "down_delay", down_delay)
        if order is not None:
            pulumi.set(__self__, "order", order)
        if up_delay is not None:
            pulumi.set(__self__, "up_delay", up_delay)

    @property
    @pulumi.getter(name="downDelay")
    def down_delay(self) -> Optional[builtins.int]:
        """
        A non-negative number defining the delay in
        seconds before the next container is shut down.
        """
        return pulumi.get(self, "down_delay")

    @property
    @pulumi.getter
    def order(self) -> Optional[builtins.int]:
        """
        A non-negative number defining the general startup
        order.
        """
        return pulumi.get(self, "order")

    @property
    @pulumi.getter(name="upDelay")
    def up_delay(self) -> Optional[builtins.int]:
        """
        A non-negative number defining the delay in
        seconds before the next container is started.
        """
        return pulumi.get(self, "up_delay")


