# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'FileSourceFileArgs',
    'FileSourceFileArgsDict',
    'FileSourceRawArgs',
    'FileSourceRawArgsDict',
    'GetDatastoresDatastoreArgs',
    'GetDatastoresDatastoreArgsDict',
    'GetDatastoresFiltersArgs',
    'GetDatastoresFiltersArgsDict',
]

MYPY = False

if not MYPY:
    class FileSourceFileArgsDict(TypedDict):
        path: pulumi.Input[builtins.str]
        """
        A path to a local file or a URL.
        """
        changed: NotRequired[pulumi.Input[builtins.bool]]
        """
        Whether the source file has changed since the last run
        """
        checksum: NotRequired[pulumi.Input[builtins.str]]
        """
        The SHA256 checksum of the source file.
        """
        file_name: NotRequired[pulumi.Input[builtins.str]]
        """
        The file name to use instead of the source file
        name. Useful when the source file does not have a valid file extension,
        for example when the source file is a URL referencing a `.qcow2` image.
        """
        insecure: NotRequired[pulumi.Input[builtins.bool]]
        """
        Whether to skip the TLS verification step for
        HTTPS sources (defaults to `false`).
        """
        min_tls: NotRequired[pulumi.Input[builtins.str]]
        """
        The minimum required TLS version for HTTPS
        sources. "Supported values: `1.0|1.1|1.2|1.3` (defaults to `1.3`).
        """
elif False:
    FileSourceFileArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class FileSourceFileArgs:
    def __init__(__self__, *,
                 path: pulumi.Input[builtins.str],
                 changed: Optional[pulumi.Input[builtins.bool]] = None,
                 checksum: Optional[pulumi.Input[builtins.str]] = None,
                 file_name: Optional[pulumi.Input[builtins.str]] = None,
                 insecure: Optional[pulumi.Input[builtins.bool]] = None,
                 min_tls: Optional[pulumi.Input[builtins.str]] = None):
        """
        :param pulumi.Input[builtins.str] path: A path to a local file or a URL.
        :param pulumi.Input[builtins.bool] changed: Whether the source file has changed since the last run
        :param pulumi.Input[builtins.str] checksum: The SHA256 checksum of the source file.
        :param pulumi.Input[builtins.str] file_name: The file name to use instead of the source file
               name. Useful when the source file does not have a valid file extension,
               for example when the source file is a URL referencing a `.qcow2` image.
        :param pulumi.Input[builtins.bool] insecure: Whether to skip the TLS verification step for
               HTTPS sources (defaults to `false`).
        :param pulumi.Input[builtins.str] min_tls: The minimum required TLS version for HTTPS
               sources. "Supported values: `1.0|1.1|1.2|1.3` (defaults to `1.3`).
        """
        pulumi.set(__self__, "path", path)
        if changed is not None:
            pulumi.set(__self__, "changed", changed)
        if checksum is not None:
            pulumi.set(__self__, "checksum", checksum)
        if file_name is not None:
            pulumi.set(__self__, "file_name", file_name)
        if insecure is not None:
            pulumi.set(__self__, "insecure", insecure)
        if min_tls is not None:
            pulumi.set(__self__, "min_tls", min_tls)

    @property
    @pulumi.getter
    def path(self) -> pulumi.Input[builtins.str]:
        """
        A path to a local file or a URL.
        """
        return pulumi.get(self, "path")

    @path.setter
    def path(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "path", value)

    @property
    @pulumi.getter
    def changed(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether the source file has changed since the last run
        """
        return pulumi.get(self, "changed")

    @changed.setter
    def changed(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "changed", value)

    @property
    @pulumi.getter
    def checksum(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The SHA256 checksum of the source file.
        """
        return pulumi.get(self, "checksum")

    @checksum.setter
    def checksum(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "checksum", value)

    @property
    @pulumi.getter(name="fileName")
    def file_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The file name to use instead of the source file
        name. Useful when the source file does not have a valid file extension,
        for example when the source file is a URL referencing a `.qcow2` image.
        """
        return pulumi.get(self, "file_name")

    @file_name.setter
    def file_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "file_name", value)

    @property
    @pulumi.getter
    def insecure(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to skip the TLS verification step for
        HTTPS sources (defaults to `false`).
        """
        return pulumi.get(self, "insecure")

    @insecure.setter
    def insecure(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "insecure", value)

    @property
    @pulumi.getter(name="minTls")
    def min_tls(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The minimum required TLS version for HTTPS
        sources. "Supported values: `1.0|1.1|1.2|1.3` (defaults to `1.3`).
        """
        return pulumi.get(self, "min_tls")

    @min_tls.setter
    def min_tls(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "min_tls", value)


if not MYPY:
    class FileSourceRawArgsDict(TypedDict):
        data: pulumi.Input[builtins.str]
        """
        The raw data.
        """
        file_name: pulumi.Input[builtins.str]
        """
        The file name.
        """
        resize: NotRequired[pulumi.Input[builtins.int]]
        """
        The number of bytes to resize the file to.
        """
elif False:
    FileSourceRawArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class FileSourceRawArgs:
    def __init__(__self__, *,
                 data: pulumi.Input[builtins.str],
                 file_name: pulumi.Input[builtins.str],
                 resize: Optional[pulumi.Input[builtins.int]] = None):
        """
        :param pulumi.Input[builtins.str] data: The raw data.
        :param pulumi.Input[builtins.str] file_name: The file name.
        :param pulumi.Input[builtins.int] resize: The number of bytes to resize the file to.
        """
        pulumi.set(__self__, "data", data)
        pulumi.set(__self__, "file_name", file_name)
        if resize is not None:
            pulumi.set(__self__, "resize", resize)

    @property
    @pulumi.getter
    def data(self) -> pulumi.Input[builtins.str]:
        """
        The raw data.
        """
        return pulumi.get(self, "data")

    @data.setter
    def data(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "data", value)

    @property
    @pulumi.getter(name="fileName")
    def file_name(self) -> pulumi.Input[builtins.str]:
        """
        The file name.
        """
        return pulumi.get(self, "file_name")

    @file_name.setter
    def file_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "file_name", value)

    @property
    @pulumi.getter
    def resize(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The number of bytes to resize the file to.
        """
        return pulumi.get(self, "resize")

    @resize.setter
    def resize(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "resize", value)


if not MYPY:
    class GetDatastoresDatastoreArgsDict(TypedDict):
        content_types: Sequence[builtins.str]
        """
        Allowed store content types.
        """
        id: builtins.str
        """
        The ID of the store.
        """
        node_name: builtins.str
        """
        The name of the node the store is on.
        """
        type: builtins.str
        """
        Store type.
        """
        active: NotRequired[builtins.bool]
        """
        Whether the store is active.
        """
        enabled: NotRequired[builtins.bool]
        """
        Whether the store is enabled.
        """
        shared: NotRequired[builtins.bool]
        """
        Shared flag from store configuration.
        """
        space_available: NotRequired[builtins.int]
        """
        Available store space in bytes.
        """
        space_total: NotRequired[builtins.int]
        """
        Total store space in bytes.
        """
        space_used: NotRequired[builtins.int]
        """
        Used store space in bytes.
        """
        space_used_fraction: NotRequired[builtins.float]
        """
        Used fraction (used/total).
        """
elif False:
    GetDatastoresDatastoreArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class GetDatastoresDatastoreArgs:
    def __init__(__self__, *,
                 content_types: Sequence[builtins.str],
                 id: builtins.str,
                 node_name: builtins.str,
                 type: builtins.str,
                 active: Optional[builtins.bool] = None,
                 enabled: Optional[builtins.bool] = None,
                 shared: Optional[builtins.bool] = None,
                 space_available: Optional[builtins.int] = None,
                 space_total: Optional[builtins.int] = None,
                 space_used: Optional[builtins.int] = None,
                 space_used_fraction: Optional[builtins.float] = None):
        """
        :param Sequence[builtins.str] content_types: Allowed store content types.
        :param builtins.str id: The ID of the store.
        :param builtins.str node_name: The name of the node the store is on.
        :param builtins.str type: Store type.
        :param builtins.bool active: Whether the store is active.
        :param builtins.bool enabled: Whether the store is enabled.
        :param builtins.bool shared: Shared flag from store configuration.
        :param builtins.int space_available: Available store space in bytes.
        :param builtins.int space_total: Total store space in bytes.
        :param builtins.int space_used: Used store space in bytes.
        :param builtins.float space_used_fraction: Used fraction (used/total).
        """
        pulumi.set(__self__, "content_types", content_types)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "node_name", node_name)
        pulumi.set(__self__, "type", type)
        if active is not None:
            pulumi.set(__self__, "active", active)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if shared is not None:
            pulumi.set(__self__, "shared", shared)
        if space_available is not None:
            pulumi.set(__self__, "space_available", space_available)
        if space_total is not None:
            pulumi.set(__self__, "space_total", space_total)
        if space_used is not None:
            pulumi.set(__self__, "space_used", space_used)
        if space_used_fraction is not None:
            pulumi.set(__self__, "space_used_fraction", space_used_fraction)

    @property
    @pulumi.getter(name="contentTypes")
    def content_types(self) -> Sequence[builtins.str]:
        """
        Allowed store content types.
        """
        return pulumi.get(self, "content_types")

    @content_types.setter
    def content_types(self, value: Sequence[builtins.str]):
        pulumi.set(self, "content_types", value)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The ID of the store.
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: builtins.str):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter(name="nodeName")
    def node_name(self) -> builtins.str:
        """
        The name of the node the store is on.
        """
        return pulumi.get(self, "node_name")

    @node_name.setter
    def node_name(self, value: builtins.str):
        pulumi.set(self, "node_name", value)

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        Store type.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: builtins.str):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def active(self) -> Optional[builtins.bool]:
        """
        Whether the store is active.
        """
        return pulumi.get(self, "active")

    @active.setter
    def active(self, value: Optional[builtins.bool]):
        pulumi.set(self, "active", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[builtins.bool]:
        """
        Whether the store is enabled.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[builtins.bool]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter
    def shared(self) -> Optional[builtins.bool]:
        """
        Shared flag from store configuration.
        """
        return pulumi.get(self, "shared")

    @shared.setter
    def shared(self, value: Optional[builtins.bool]):
        pulumi.set(self, "shared", value)

    @property
    @pulumi.getter(name="spaceAvailable")
    def space_available(self) -> Optional[builtins.int]:
        """
        Available store space in bytes.
        """
        return pulumi.get(self, "space_available")

    @space_available.setter
    def space_available(self, value: Optional[builtins.int]):
        pulumi.set(self, "space_available", value)

    @property
    @pulumi.getter(name="spaceTotal")
    def space_total(self) -> Optional[builtins.int]:
        """
        Total store space in bytes.
        """
        return pulumi.get(self, "space_total")

    @space_total.setter
    def space_total(self, value: Optional[builtins.int]):
        pulumi.set(self, "space_total", value)

    @property
    @pulumi.getter(name="spaceUsed")
    def space_used(self) -> Optional[builtins.int]:
        """
        Used store space in bytes.
        """
        return pulumi.get(self, "space_used")

    @space_used.setter
    def space_used(self, value: Optional[builtins.int]):
        pulumi.set(self, "space_used", value)

    @property
    @pulumi.getter(name="spaceUsedFraction")
    def space_used_fraction(self) -> Optional[builtins.float]:
        """
        Used fraction (used/total).
        """
        return pulumi.get(self, "space_used_fraction")

    @space_used_fraction.setter
    def space_used_fraction(self, value: Optional[builtins.float]):
        pulumi.set(self, "space_used_fraction", value)


if not MYPY:
    class GetDatastoresFiltersArgsDict(TypedDict):
        content_types: NotRequired[Sequence[builtins.str]]
        """
        Only list stores with the given content types.
        """
        id: NotRequired[builtins.str]
        """
        Only list stores with the given ID.
        """
        target: NotRequired[builtins.str]
        """
        If `target` is different to `node_name`, then only lists shared stores which content is accessible on this node and the specified `target` node.
        """
elif False:
    GetDatastoresFiltersArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class GetDatastoresFiltersArgs:
    def __init__(__self__, *,
                 content_types: Optional[Sequence[builtins.str]] = None,
                 id: Optional[builtins.str] = None,
                 target: Optional[builtins.str] = None):
        """
        :param Sequence[builtins.str] content_types: Only list stores with the given content types.
        :param builtins.str id: Only list stores with the given ID.
        :param builtins.str target: If `target` is different to `node_name`, then only lists shared stores which content is accessible on this node and the specified `target` node.
        """
        if content_types is not None:
            pulumi.set(__self__, "content_types", content_types)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if target is not None:
            pulumi.set(__self__, "target", target)

    @property
    @pulumi.getter(name="contentTypes")
    def content_types(self) -> Optional[Sequence[builtins.str]]:
        """
        Only list stores with the given content types.
        """
        return pulumi.get(self, "content_types")

    @content_types.setter
    def content_types(self, value: Optional[Sequence[builtins.str]]):
        pulumi.set(self, "content_types", value)

    @property
    @pulumi.getter
    def id(self) -> Optional[builtins.str]:
        """
        Only list stores with the given ID.
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[builtins.str]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter
    def target(self) -> Optional[builtins.str]:
        """
        If `target` is different to `node_name`, then only lists shared stores which content is accessible on this node and the specified `target` node.
        """
        return pulumi.get(self, "target")

    @target.setter
    def target(self, value: Optional[builtins.str]):
        pulumi.set(self, "target", value)


