# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'FileSourceFile',
    'FileSourceRaw',
    'GetDatastoresDatastoreResult',
    'GetDatastoresFiltersResult',
]

@pulumi.output_type
class FileSourceFile(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "fileName":
            suggest = "file_name"
        elif key == "minTls":
            suggest = "min_tls"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in FileSourceFile. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        FileSourceFile.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        FileSourceFile.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 path: builtins.str,
                 changed: Optional[builtins.bool] = None,
                 checksum: Optional[builtins.str] = None,
                 file_name: Optional[builtins.str] = None,
                 insecure: Optional[builtins.bool] = None,
                 min_tls: Optional[builtins.str] = None):
        """
        :param builtins.str path: A path to a local file or a URL.
        :param builtins.bool changed: Whether the source file has changed since the last run
        :param builtins.str checksum: The SHA256 checksum of the source file.
        :param builtins.str file_name: The file name to use instead of the source file
               name. Useful when the source file does not have a valid file extension,
               for example when the source file is a URL referencing a `.qcow2` image.
        :param builtins.bool insecure: Whether to skip the TLS verification step for
               HTTPS sources (defaults to `false`).
        :param builtins.str min_tls: The minimum required TLS version for HTTPS
               sources. "Supported values: `1.0|1.1|1.2|1.3` (defaults to `1.3`).
        """
        pulumi.set(__self__, "path", path)
        if changed is not None:
            pulumi.set(__self__, "changed", changed)
        if checksum is not None:
            pulumi.set(__self__, "checksum", checksum)
        if file_name is not None:
            pulumi.set(__self__, "file_name", file_name)
        if insecure is not None:
            pulumi.set(__self__, "insecure", insecure)
        if min_tls is not None:
            pulumi.set(__self__, "min_tls", min_tls)

    @property
    @pulumi.getter
    def path(self) -> builtins.str:
        """
        A path to a local file or a URL.
        """
        return pulumi.get(self, "path")

    @property
    @pulumi.getter
    def changed(self) -> Optional[builtins.bool]:
        """
        Whether the source file has changed since the last run
        """
        return pulumi.get(self, "changed")

    @property
    @pulumi.getter
    def checksum(self) -> Optional[builtins.str]:
        """
        The SHA256 checksum of the source file.
        """
        return pulumi.get(self, "checksum")

    @property
    @pulumi.getter(name="fileName")
    def file_name(self) -> Optional[builtins.str]:
        """
        The file name to use instead of the source file
        name. Useful when the source file does not have a valid file extension,
        for example when the source file is a URL referencing a `.qcow2` image.
        """
        return pulumi.get(self, "file_name")

    @property
    @pulumi.getter
    def insecure(self) -> Optional[builtins.bool]:
        """
        Whether to skip the TLS verification step for
        HTTPS sources (defaults to `false`).
        """
        return pulumi.get(self, "insecure")

    @property
    @pulumi.getter(name="minTls")
    def min_tls(self) -> Optional[builtins.str]:
        """
        The minimum required TLS version for HTTPS
        sources. "Supported values: `1.0|1.1|1.2|1.3` (defaults to `1.3`).
        """
        return pulumi.get(self, "min_tls")


@pulumi.output_type
class FileSourceRaw(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "fileName":
            suggest = "file_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in FileSourceRaw. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        FileSourceRaw.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        FileSourceRaw.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 data: builtins.str,
                 file_name: builtins.str,
                 resize: Optional[builtins.int] = None):
        """
        :param builtins.str data: The raw data.
        :param builtins.str file_name: The file name.
        :param builtins.int resize: The number of bytes to resize the file to.
        """
        pulumi.set(__self__, "data", data)
        pulumi.set(__self__, "file_name", file_name)
        if resize is not None:
            pulumi.set(__self__, "resize", resize)

    @property
    @pulumi.getter
    def data(self) -> builtins.str:
        """
        The raw data.
        """
        return pulumi.get(self, "data")

    @property
    @pulumi.getter(name="fileName")
    def file_name(self) -> builtins.str:
        """
        The file name.
        """
        return pulumi.get(self, "file_name")

    @property
    @pulumi.getter
    def resize(self) -> Optional[builtins.int]:
        """
        The number of bytes to resize the file to.
        """
        return pulumi.get(self, "resize")


@pulumi.output_type
class GetDatastoresDatastoreResult(dict):
    def __init__(__self__, *,
                 content_types: Sequence[builtins.str],
                 id: builtins.str,
                 node_name: builtins.str,
                 type: builtins.str,
                 active: Optional[builtins.bool] = None,
                 enabled: Optional[builtins.bool] = None,
                 shared: Optional[builtins.bool] = None,
                 space_available: Optional[builtins.int] = None,
                 space_total: Optional[builtins.int] = None,
                 space_used: Optional[builtins.int] = None,
                 space_used_fraction: Optional[builtins.float] = None):
        """
        :param Sequence[builtins.str] content_types: Allowed store content types.
        :param builtins.str id: The ID of the store.
        :param builtins.str node_name: The name of the node the store is on.
        :param builtins.str type: Store type.
        :param builtins.bool active: Whether the store is active.
        :param builtins.bool enabled: Whether the store is enabled.
        :param builtins.bool shared: Shared flag from store configuration.
        :param builtins.int space_available: Available store space in bytes.
        :param builtins.int space_total: Total store space in bytes.
        :param builtins.int space_used: Used store space in bytes.
        :param builtins.float space_used_fraction: Used fraction (used/total).
        """
        pulumi.set(__self__, "content_types", content_types)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "node_name", node_name)
        pulumi.set(__self__, "type", type)
        if active is not None:
            pulumi.set(__self__, "active", active)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if shared is not None:
            pulumi.set(__self__, "shared", shared)
        if space_available is not None:
            pulumi.set(__self__, "space_available", space_available)
        if space_total is not None:
            pulumi.set(__self__, "space_total", space_total)
        if space_used is not None:
            pulumi.set(__self__, "space_used", space_used)
        if space_used_fraction is not None:
            pulumi.set(__self__, "space_used_fraction", space_used_fraction)

    @property
    @pulumi.getter(name="contentTypes")
    def content_types(self) -> Sequence[builtins.str]:
        """
        Allowed store content types.
        """
        return pulumi.get(self, "content_types")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The ID of the store.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="nodeName")
    def node_name(self) -> builtins.str:
        """
        The name of the node the store is on.
        """
        return pulumi.get(self, "node_name")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        Store type.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def active(self) -> Optional[builtins.bool]:
        """
        Whether the store is active.
        """
        return pulumi.get(self, "active")

    @property
    @pulumi.getter
    def enabled(self) -> Optional[builtins.bool]:
        """
        Whether the store is enabled.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def shared(self) -> Optional[builtins.bool]:
        """
        Shared flag from store configuration.
        """
        return pulumi.get(self, "shared")

    @property
    @pulumi.getter(name="spaceAvailable")
    def space_available(self) -> Optional[builtins.int]:
        """
        Available store space in bytes.
        """
        return pulumi.get(self, "space_available")

    @property
    @pulumi.getter(name="spaceTotal")
    def space_total(self) -> Optional[builtins.int]:
        """
        Total store space in bytes.
        """
        return pulumi.get(self, "space_total")

    @property
    @pulumi.getter(name="spaceUsed")
    def space_used(self) -> Optional[builtins.int]:
        """
        Used store space in bytes.
        """
        return pulumi.get(self, "space_used")

    @property
    @pulumi.getter(name="spaceUsedFraction")
    def space_used_fraction(self) -> Optional[builtins.float]:
        """
        Used fraction (used/total).
        """
        return pulumi.get(self, "space_used_fraction")


@pulumi.output_type
class GetDatastoresFiltersResult(dict):
    def __init__(__self__, *,
                 content_types: Optional[Sequence[builtins.str]] = None,
                 id: Optional[builtins.str] = None,
                 target: Optional[builtins.str] = None):
        """
        :param Sequence[builtins.str] content_types: Only list stores with the given content types.
        :param builtins.str id: Only list stores with the given ID.
        :param builtins.str target: If `target` is different to `node_name`, then only lists shared stores which content is accessible on this node and the specified `target` node.
        """
        if content_types is not None:
            pulumi.set(__self__, "content_types", content_types)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if target is not None:
            pulumi.set(__self__, "target", target)

    @property
    @pulumi.getter(name="contentTypes")
    def content_types(self) -> Optional[Sequence[builtins.str]]:
        """
        Only list stores with the given content types.
        """
        return pulumi.get(self, "content_types")

    @property
    @pulumi.getter
    def id(self) -> Optional[builtins.str]:
        """
        Only list stores with the given ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def target(self) -> Optional[builtins.str]:
        """
        If `target` is different to `node_name`, then only lists shared stores which content is accessible on this node and the specified `target` node.
        """
        return pulumi.get(self, "target")


